// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { QueryBus } from "../../../core/query/QueryBus";
import Injectable from "../../../core/injectable/Injectable";
import GetRegulationDetailsRequest from "../request/factory/GetRegulationDetailsRequest";
import { LogError } from "../../../core/decorator/LogErrorDecorator";
import ValidatedRequest from "../../../core/validation/ValidatedArgs";
import { GetRegulationDetailsQuery } from "../../../app/usecase/query/factory/get/GetRegulationDetailsQuery";
import ContractId from "../../../domain/context/contract/ContractId";
import NetworkService from "../../../app/service/network/NetworkService";
class FactoryInPort {
    queryBus;
    networkService;
    constructor(queryBus = Injectable.resolve(QueryBus), networkService = Injectable.resolve(NetworkService)) {
        this.queryBus = queryBus;
        this.networkService = networkService;
    }
    async getRegulationDetails(request) {
        ValidatedRequest.handleValidation("GetRegulationDetailsRequest", request);
        const securityFactory = this.networkService.configuration.factoryAddress;
        const res = await this.queryBus.execute(new GetRegulationDetailsQuery(request.regulationType, request.regulationSubType, securityFactory ? new ContractId(securityFactory) : undefined));
        const regulation = res.regulation;
        return {
            ...regulation,
        };
    }
}
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [GetRegulationDetailsRequest]),
    __metadata("design:returntype", Promise)
], FactoryInPort.prototype, "getRegulationDetails", null);
const Factory = new FactoryInPort();
export default Factory;
